// all intros in here
#include "chris.h"


// well the circle routine was older than 3d...
// so I'm lazy and reuse it
// but the cosinus/sinus tables were larger
//
// ... so now we two of them:-)
/* Cosinus data: */
static unsigned char cosinus[] = {
        127, 126, 126, 125, 124, 123, 121, 119, 117, 114, 111,  /* 11 */
        108, 105, 101, 97, 93, 89, 84, 79, 74, 69, 64,  /* 22 */
        58, 53, 47, 41, 35, 29, 23, 17, 10, 4, 255,     /* 33 */
        249, 242, 236, 230, 224, 218, 212, 206, 200, 195, 189,  /* 44 */
        184, 179, 174, 170, 165, 161, 157, 153, 150, 146, 143,  /* 55 */
        141, 138, 136, 134, 133, 131, 130, 130, 130, 130, 130,  /* 66 */
        130, 131, 133, 134, 136, 138, 141, 143, 146, 150, 153,  /* 77 */
        157, 161, 165, 170, 174, 179, 184, 189, 195, 200, 206,  /* 88 */
        212, 218, 224, 230, 236, 242, 249, 255, 4, 10, 17,      /* 99 */
        23, 29, 35, 41, 47, 53, 58, 64, 69, 74, 79,     /* 110 */
        84, 89, 93, 97, 101, 105, 108, 111, 114, 117, 119,      /* 121 */
        121, 123, 124, 125, 126, 126, 127
 };

/* Sinus data: */
static unsigned char sinus[] = {
        0, 6, 12, 18, 24, 31, 37, 43, 48, 54, 60,        /* 11 */
        65, 71, 76, 81, 85, 90, 94, 98, 102, 106, 109,   /* 22 */
        112, 115, 117, 119, 121, 123, 124, 125, 126, 126, 126,   /* 33 */
        126, 126, 125, 124, 122, 120, 118, 116, 113, 111, 107,   /* 44 */
        104, 100, 96, 92, 88, 83, 78, 73, 68, 63, 57,    /* 55 */
        51, 46, 40, 34, 28, 21, 15, 9, 3, 253, 247,      /* 66 */
        241, 235, 228, 222, 216, 210, 205, 199, 193, 188, 183,   /* 77 */
        178, 173, 168, 164, 160, 156, 152, 149, 145, 143, 140,   /* 88 */
        138, 136, 134, 132, 131, 130, 130, 130, 130, 130, 131,   /* 99 */
        132, 133, 135, 137, 139, 141, 144, 147, 150, 154, 158,   /* 110 */
        162, 166, 171, 175, 180, 185, 191, 196, 202, 208, 213,   /* 121 */
        219, 225, 232, 238, 244, 250, 0
 };

#define SHOT_SCALE 120                  /* for positioning the dots on the screen */
#define SHOTS_USED 16
#define DOT_BRIGHTNESS 5                /* dot dwell time... */

struct shot                             /* one shot... */
{
  unsigned short counter;
  unsigned char radius;
  unsigned char delta_x;
  unsigned char delta_y;
};

struct shot current_shots[SHOTS_USED];       /* all dots bundled */

unsigned char current_active_shots;
unsigned char current_active_shot;
unsigned char innerCounter;
unsigned char radiusreached;
/*
 * Inlined static... insures this is 'really' inlined completely...
 *
 * Initialize all dots to starting defaults...
 *
 */
static inline void init_new_shot5(void)
{
 unsigned char i;
 unsigned char j;

 j=0;
 for (i=0; i<128; i+= 128/SHOTS_USED)
 {
  current_shots[j].radius = 0;
  current_shots[j].counter = i;
  current_shots[j].delta_x = cosinus[i];
  current_shots[j].delta_y = sinus[i];
  j++;
 }
 current_active_shots = SHOTS_USED;
 innerCounter = 0;
 radiusreached = 0;
}

/*
 * Inlined static... insures this is 'really' inlined completely...
 *
 * Initialize all dots to starting defaults...
 *
 */
static inline void init_circle(void)
{
 unsigned char i;
 unsigned char j;

 j=0;
 for (i=0; i<128; i+= 128/SHOTS_USED)
 {
  current_shots[j].radius = 100;
  current_shots[j].counter = i;
  current_shots[j].delta_x = cosinus[i];
  current_shots[j].delta_y = sinus[i];
  j++;
 }
 current_active_shots = SHOTS_USED;
 innerCounter = 0;
 radiusreached = 1;
}

/*
 * Inlined static... insures this is 'really' inlined completely...
 *
 * Process one dot...
 *
 */
// 5!!!
// there were once 4 other shot demos
// canceled!
// now we do only 3d stuff here
static inline void do_shot5(struct shot *current_shot)
{
 zero_beam();
 {
  current_shot->delta_x = cosinus[current_shot->counter];
  current_shot->delta_y = sinus[current_shot->counter];
  current_shot->counter++;
  if (current_shot->counter == 128)
  {
   current_shot->counter = 0;
  }

  if (current_active_shot == 0)
  {
   if (current_shot->radius < 100)
   {
    current_shots[0].radius++;
   }
   else
   {
    radiusreached = 1;
   }
  }
 }

 /* now draw the dot */
 set_scale(current_shots[0].radius);                    /* set scale for circle */
 write_ram(Vec_Dot_Dwell, DOT_BRIGHTNESS); /* first set up the dot dwell time */
 draw_dot(current_shot->delta_x, current_shot->delta_y); /* position and draw the dot */
}

static inline void do_shotE(struct shot *current_shot)
{
 zero_beam();
 current_shot->delta_x = cosinus[current_shot->counter];
 current_shot->delta_y = sinus[current_shot->counter];
 current_shot->counter++;
 if (current_shot->counter == 128)
 {
  current_shot->counter = 0;
 }

 /* now draw the dot */
 draw_dot(current_shot->delta_x, current_shot->delta_y); /* position and draw the dot */
}

static inline void print_shot5()
{
 unsigned char i;
 if (radiusreached == 1)
 {
  set_scale(current_shots[0].radius);                    /* set scale for circle */
  write_ram(Vec_Dot_Dwell, DOT_BRIGHTNESS); /* first set up the dot dwell time */
 }
 for (i=0; i < current_active_shots; i++)   /* and process all dots */
 {
  if (radiusreached == 0)
  {
   current_active_shot = i;
   do_shot5(&current_shots[i]); /* with this function ... */
  }
  else
  {
   do_shotE(&current_shots[i]);
  }
 }
}

void intro()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&GMS_data);
 init_new_shot5();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  if (radiusreached == 1)
  {
   zero_beam();
   if (counter < 50)
   {
    counter++;
    print_str(-44, 20, "3D DEMO");
   }
   else if ((counter >= 50) && (counter < 100))
   {
    counter++;
    print_str(-44, 20, "3D DEMO");
    zero_beam();
    print_str(-17, -20, "BY");
   }
   else
   {
    zero_beam();
    clcounter+=2;
    if (clcounter < 160)
    {
     copy_cl(clcounter); // this initialises the handwritten 'CHRIS'
                         // for as many 'pixels' as the clcounter!
    }
    else
    {
     counter++;
     if (counter > 200) break;
    }
    move_to(-40,0);
    set_scale(10);
    draw_mcl(); // draw the 'CHRIS'
   }
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_cube()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&PABLO5_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-48, 20, "THE CUBE");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_bird()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&SC6_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-48, 20, "THE BIRD");
   print_str(-55,-20, "(SORT OF)");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_sbird()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&SC6_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-48, 20, " BIRDS!");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else if ((counter >= 240) && (counter < 360))
  {
   counter++;
   print_str(-82, 20, "USE J2-1 BUTTON");
   zero_beam();
   print_str(-82, -20,"TO SELCET BIRD!");
  }
  else if ((counter >= 360) && (counter < 480))
  {
   counter++;
   print_str(-75, 40, "USE J2-2 J2-3");
   zero_beam();
   print_str(-50, 00, "BUTTONS");
   zero_beam();
   print_str(-75, -40,"TO MOVE BIRD!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_pyramid()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&PABLO5_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-67, 20, "THE PYRAMIDS");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else if ((counter >= 240) && (counter < 360))
  {
   counter++;
   print_str(-105, 20, "ALL HAVE DIFFERENT");
   zero_beam();
   print_str(-45, -20, "ANGLES!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_p2yramid()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&PABLO5_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-80, 20, "THE PYRAMIDS 2");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else if ((counter >= 240) && (counter < 360))
  {
   counter++;
   print_str(-80, 20, "ALL HAVE SAME");
   zero_beam();
   print_str(-45, -20, "ANGLES!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_last()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&GMS_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-65, 20, "SOME SHAPES");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-98, 20, "USE 2,3,4 BUTTONS");
   zero_beam();
   print_str(-55, -20, "TO ROTATE!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}


void intro_elite()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&SC6_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 240)
  {
   counter++;
   print_str(-35, 20, "ELITE!");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}

void intro_rip()
{
 volatile unsigned short counter;
 volatile unsigned short clcounter;
 counter = 0;
 clcounter = 0;
 ym_init(&BADDIE_data);
 init_circle();
 do
 {
  start_one_vectrex_round();  /* start vectrex round */
  intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

  move_to(0,0);
  print_shot5();
  zero_beam();
  if (counter < 120)
  {
   counter++;
   print_str(-65, 20, "FOR BAVRON!");
  }
  else if ((counter >= 120) && (counter < 240))
  {
   counter++;
   print_str(-65, 20, "FOR BAVRON!");
   zero_beam();
   print_str(-45, -20, "THE END");
  }
  else
  {
   break;
  }
  read_buttons();             /* read buttons, if pressed... finish here */
 }
 while (!joystick1_button1);   /* was a button pressed ? */
}
