#include <vectrex.h>
#include <ymsound.h>
#include <scroll.h>

#include "local.h"
#include "defs.h"
#include "vars.h"

#include "graphics.h"
#include "levels.i"
#include "helper.i"
#include "shot.i"

extern const void RAINBOW_data;
const unsigned char text[] = "THIS MIGHT SOMEDAY BECOME A LOADRUNNER CLONE...   ";

FUNCTION_TYPE void init_new_game(void)
{
  unsigned char i;
  level = 0;
  game_over = 0;
  for (i=0; i<SHOTS; i++)
  {
    current_shots[i].shot_counter = 10;
  }
  player_x = 0;
  player_y = 0;
  player_speed = 1;
  player_heading = _LEFT;
  player_anim_counter = 0;
  anim_delay = 2;

  if (level == 0)
  {
    testx = level1x;
    testy = level1y;
    draw_level = level1;
  }
  ym_init(&RAINBOW_data); /* 'C' callable init, sound data */
}

FUNCTION_TYPE intro(void)
{
  scr_y = 0;
  scr_lbnd= -100;
  scr_rbnd= 100;
  scr_sped=-1;
  scr_ints=MAX_BRIGHTNESS;

  scroll_init(text);
  do
  {
    start_one_vectrex_round();
    set_scale(MAX_SCALE);
    move_to(0, BOTTOM_MOST-BOTTOM_MOST/3);

    scr_step();
    read_buttons();
  }
  while (!joystick1_button1);
}

FUNCTION_TYPE void calc_player()
{
  if (joystick1_x<0) /* LEFT */
  {
    player_heading = _LEFT;
    if (testx())
      player_x -= player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (player_anim_counter == 0)
      {
        player_anim_counter = MAN_ANIM_MAX-1;
      }
      else
      {
        player_anim_counter--;
      }
    }
  }
  else if (joystick1_x>0) /* RIGHT */
  {
    player_heading = _RIGHT;
    if (testx())
      player_x += player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (player_anim_counter == MAN_ANIM_MAX-1)
      {
        player_anim_counter = 0;
      }
      else
      {
        player_anim_counter++;
      }
    }
  }
  if (joystick1_y<0) /* DOWN */
  {
    player_heading = _DOWN;
    if (testy())
      player_y-=player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (player_anim_counter == 0)
      {
        player_anim_counter = MAN_ANIM_MAX-1;
      }
      else
      {
        player_anim_counter--;
      }
    }
  }
  else if (joystick1_y>0) /* UP */
  {
    player_heading = _UP;
    if (testy())
      player_y+=player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (player_anim_counter == MAN_ANIM_MAX-1)
      {
        player_anim_counter = 0;
      }
      else
      {
        player_anim_counter++;
      }
    }
  }
}

FUNCTION_TYPE draw_player()
{
  zero_beam();
  set_scale(MAX_SCALE);
  calc_player();
  move_to(player_x, player_y);
  set_scale(MAN_SCALE);
  draw_vector_list(man[player_heading][player_anim_counter]);
}

int main(void)
{
  setup();
  while (true)
  {
    intro();

    init_new_game();
    while (!game_over)
    {
/*
      ym_sound();
      if (ym_cdata == 0)
      {
       ym_init(&RAINBOW_data);
      }
*/
      start_one_vectrex_round();



      intensity(MAX_BRIGHTNESS);
      draw_level();

      for (i=0; i < SHOTS; i++)
      {
        do_shot(&current_shots[i]);
      }

      draw_player();
      joy_digital();
      read_buttons();
    }
  }
}

/*
pro level function:

is x allowed
is y allowed
modify x
modify y

*/