#ifndef _DEFS_H_
#define _DEFS_H_

/*
 * Game appearance definitions
 */
#define MAX_BRIGHTNESS (0x7f)
#define MAX_SCALE (255)
#define LEFT_MOST ((signed char) (-128))
#define RIGHT_MOST ((signed char) (127))
#define TOP_MOST ((signed char) (127))
#define BOTTOM_MOST ((signed char) (-128))


/*
 * Game definitions
 */
#define SHOTS 2
#define SHOT_SOUND_DURATION (5)
#define DOT_BRIGHTNESS 5
#define SHOT_INTERVALL 50
#define ANIM_DELAY_INIT 3

#define SHOT_TYPE_BOTTOM_X 0
#define SHOT_TYPE_TOP_X 1
#define SHOT_TYPE_LEFT_Y 2
#define SHOT_TYPE_RIGHT_Y 3

/*
 * Directions
 */
#define TO_HALF_THREE 0
#define TO_THREE 1
#define TO_HALF_SIX 2
#define TO_SIX 3
#define TO_HALF_NINE 4
#define TO_NINE 5
#define TO_HALF_TWELF 6
#define TO_TWELF 7
#define HIGHEST_DIRECTION (TO_TWELF + 1)

/*
 * Structures
 */

struct shot
{
  signed short shot_counter;
  signed char direction;
  unsigned char speed;
  unsigned char hunting;
  signed x;
  signed y;
};


#endif