#ifndef _SHOTS_I_
#define _SHOTS_I_

struct shot current_shots[SHOTS];

unsigned char shot_sound[4] = {0x38,0x10,0x00,0xf8};
unsigned char shot_sound3[4] = {0xff,0x00,0x00,0x00};

FUNCTION_TYPE void end_shot_sound()
{
  clear_sound();
}

FUNCTION_TYPE void start_shot_sound()
{
  set_dp_c8();
  write_ram(Vec_Expl_Flag, 128);
  do_explosion(shot_sound);
  set_dp_d0();
}

FUNCTION_TYPE void init_shot(struct shot *current_shot)
{
  unsigned char choice = random() & 3;
  unsigned char start = random();
  current_shot->shot_counter = -1;
  current_shot->direction = random() % HIGHEST_DIRECTION;
  current_shot->speed = 1;
  current_shot->hunting = 0;
  if (choice == SHOT_TYPE_BOTTOM_X)
  {
    current_shot->y = BOTTOM_MOST;
    current_shot->x = start;
  }
  if (choice == SHOT_TYPE_TOP_X)
  {
    current_shot->y = TOP_MOST;
    current_shot->x = start;
  }
  if (choice == SHOT_TYPE_LEFT_Y)
  {
    current_shot->y = start;
    current_shot->x = LEFT_MOST;
  }
  if (choice == SHOT_TYPE_RIGHT_Y)
  {
    current_shot->y = start;
    current_shot->x = RIGHT_MOST;
  }
  start_shot_sound();
}

FUNCTION_TYPE void do_shot(struct shot *current_shot)
{
  if (current_shot->shot_counter > 0)
  {
    current_shot->shot_counter--;
    if (current_shot->shot_counter == 0)
    {
      init_shot(current_shot);
    }
    return;
  }
  else
  {
    if (current_shot->shot_counter > -SHOT_SOUND_DURATION)
    {
      current_shot->shot_counter--;
      if (current_shot->shot_counter == -SHOT_SOUND_DURATION)
      {
        end_shot_sound();
      }
    }
    switch (current_shot->direction)
    {
     case TO_HALF_THREE:
     {
       if ((current_shot->x > 120) || (current_shot->y > 120) )
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x += current_shot->speed;
       current_shot->y += current_shot->speed;
       break;
     }
     case TO_THREE:
     {
       if (current_shot->x > 120)
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x += current_shot->speed;
       break;
     }
     case TO_HALF_SIX:
     {
       if ((current_shot->x > 120) || (current_shot->y < -120) )
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x += current_shot->speed;
       current_shot->y -= current_shot->speed;
       break;
     }
     case TO_SIX:
     {
       if (current_shot->y < -120)
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->y -= current_shot->speed;
       break;
     }
     case TO_HALF_NINE:
     {
       if ((current_shot->x < -120) || (current_shot->y < -120) )
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x -= current_shot->speed;
       current_shot->y -= current_shot->speed;
       break;
     }
     case TO_NINE:
     {
       if (current_shot->x < -120)
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x -= current_shot->speed;
       break;
     }
     case TO_HALF_TWELF:
     {
       if ((current_shot->x < -120) || (current_shot->y > 120) )
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->x -= current_shot->speed;
       current_shot->y += current_shot->speed;
       break;
     }
     case TO_TWELF:
     {
       if (current_shot->y > 120)
       {
         current_shot->shot_counter = SHOT_INTERVALL;
         return;
       }
       current_shot->y += current_shot->speed;
       break;
     }
     default:
     {
       current_shot->shot_counter = SHOT_INTERVALL;
       return;
     }
    }
  }

  // now draw the shot
 zero_beam();
 write_ram(Vec_Dot_Dwell, DOT_BRIGHTNESS);
 set_scale(120);
 draw_dot(current_shot->x, current_shot->y);
}

#endif