#include <vectrex.h>
#include <scroll.h>

#include "local.h"
#include "defs.h"
#include "vars.h"

#include "graphics.h"
#include "levels.i"
#include "helper.i"
#include "shot.i"


FUNCTION_TYPE void init_new_game(void)
{
  unsigned char i;
  level = 0;
  game_over = 0;
  for (i=0; i<SHOTS; i++)
  {
    current_shots[i].shot_counter = 10;
  }
  player_x = 0;
  player_y = 0;
  player_speed = 1;
  body_anim_counter = 0;
  arms_anim_counter = 0;
  anim_delay = 2;

  if (level == 0)
  {
    testx = level1x;
    testy = level1y;
    draw_level = level1;
  }
}

const unsigned char text[] = "CHRIS IST WIRKLICH TOLL...   ";
FUNCTION_TYPE intro(void)
{
  scr_y = 0;
  scr_lbnd= -100;
  scr_rbnd= 100;
  scr_sped=-1;
  scr_ints=MAX_BRIGHTNESS;

  scroll_init(text);
  do
  {
    start_one_vectrex_round();
    set_scale(MAX_SCALE);
    move_to(0, BOTTOM_MOST-BOTTOM_MOST/3);

    scr_step();
    read_buttons();
  }
  while (!joystick1_button1);
}

FUNCTION_TYPE void calc_player()
{
  if (joystick1_x<0) /* LEFT */
  {
    if (testx())
      player_x -= player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (body_anim_counter == 0)
      {
        body_anim_counter = BODY_ANIM_MAX-1;
      }
      else
      {
        body_anim_counter--;
      }
    }
  }
  else if (joystick1_x>0) /* RIGHT */
  {
    if (testx())
      player_x += player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (body_anim_counter == BODY_ANIM_MAX-1)
      {
        body_anim_counter = 0;
      }
      else
      {
        body_anim_counter++;
      }
    }
  }
  if (joystick1_y<0) /* DOWN */
  {
    if (testy())
      player_y-=player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (arms_anim_counter == 0)
      {
        arms_anim_counter = ARMS_ANIM_MAX-1;
      }
      else
      {
        arms_anim_counter--;
      }
    }
  }
  else if (joystick1_y>0) /* UP */
  {
    if (testy())
      player_y+=player_speed;
    anim_delay--;
    if (anim_delay == 0)
    {
      anim_delay = ANIM_DELAY_INIT;
      if (arms_anim_counter == ARMS_ANIM_MAX-1)
      {
        arms_anim_counter = 0;
      }
      else
      {
        arms_anim_counter++;
      }
    }
  }
}

FUNCTION_TYPE draw_player()
{
  zero_beam();
  set_scale(MAX_SCALE);
  calc_player();
  move_to(player_x, player_y);
  set_scale(MAN_SCALE);
  draw_vector_list(body[body_anim_counter]);

  set_scale(35);
  move_to(ARM_LEFT_OFFSET_X, ARM_LEFT_OFFSET_Y);
  set_scale(MAN_SCALE);
  draw_vector_list(arms[arms_anim_counter]);

  set_scale(50);
  move_to(ARM_RIGHT_OFFSET_X, ARM_RIGHT_OFFSET_Y);
  set_scale(MAN_SCALE);
  draw_vector_list(arms[arms_anim_counter]);

  set_scale(50);
  move_to(FACE_OFFSET_X, FACE_OFFSET_Y);
  set_scale(MAN_SCALE);
  draw_vector_list(face);
}

int main(void)
{
  setup();
  while (true)
  {
    intro();

    init_new_game();
//    play_song(SCRAMBLE_MUSIC);
    while (!game_over)
    {
      start_one_vectrex_round();
      intensity(MAX_BRIGHTNESS);
      draw_level();
      for (i=0; i < SHOTS; i++)
      {
        do_shot(&current_shots[i]);
      }
      draw_player();
      joy_digital();
      read_buttons();
    }
  }
}

/*
pro level function:

is x allowed
is y allowed
modify x
modify y

*/